#include <game.h>

#include <startmenu.h>

#include <iostream>

//TODO: WINE
//TODO: DIRECT3D9
//TODO: trouver comment mettre au premier plan la bonne fenêtre
//TODO: Bug quand on passe en pleine ecran
//TODO: Restructurer les dossiers : xml, models ... : mettre les xml prochent
//		de se à quoi ils se rapportent si possible, en tous cas restructurer
//		Par exemple tout mettre dans data, ensuite voir.
//		Ou mettre le repertoir du jeux qui contient les xml
//		Vu que le but est de faire un prog générique, je sais pas si je dois
//		intégrer la demo dans le "SDK", où bien mettre complètement à part
//TODO: Options sons
//TODO: Trouver pourquoi on a pas les accents dans la police
//TODO: Finir les boutons en anglais
//TODO: faire le ménage dans class startmenu : virer les fonctions inutiles(version, gettime...)

startmenu::startmenu()
{
	dr = EDT_SOFTWARE;
	dim = dimension2d<s32>(640, 480);
	bits = 8;
	fullscreen = false;
	stencilbuffer = false;
	vsync = false;
	
	lang = 0;
	
	menus = new std::vector<IGUIButton*>;
	menusOut = new std::vector<ITexture*>;
	menusIn = new std::vector<ITexture*>;
	starting_txt = new std::vector<stringw>;
	
	progressing=0;
}

startmenu::~startmenu()
{
	delete menus;
	delete menusIn;
	delete menusOut;
	delete starting_txt;
}

int startmenu::init(stringc p, stringc la)
{
	log(stringc("Main Folder : ") + p);
	log(stringc("Language menu : ") + la);
	
	device = createDevice(dr,dim,bits,fullscreen,stencilbuffer,vsync);
	log("Device created");
	
	driver = device->getVideoDriver();
	smgr = device->getSceneManager();
	env = device->getGUIEnvironment();
	
#ifdef AUDIO
	engine = createIrrKlangDevice();
#endif
	
	langMenu=la;

	path = p;
	pathStart = "";
	pathConfig = path + "config.xml";
	pathMain = "";
	
	device->getFileSystem()->changeWorkingDirectoryTo(path.c_str());
	
	IXMLReader* xmlConfig = device->getFileSystem()->createXMLReader(pathConfig.c_str());
	
	if (xmlConfig)
		log(stringc("Finded config file ") + pathConfig + " reading it...");
	else
	{
		log(stringc("Can't find config file ") + pathConfig + " quitting...");
		return 1;
	}
	
	while(xmlConfig && xmlConfig->read())
	{
		if (xmlConfig->getNodeType()==EXN_ELEMENT)
		{
			if (core::stringw("device") == xmlConfig->getNodeName())
			{
				dr = E_DRIVER_TYPE(xmlConfig->getAttributeValueAsInt(L"driver"));
				bits = xmlConfig->getAttributeValueAsInt(L"bits");
				fullscreen = xmlConfig->getAttributeValueAsInt(L"fs");
				stencilbuffer = xmlConfig->getAttributeValueAsInt(L"sb");
				vsync = xmlConfig->getAttributeValueAsInt(L"vs");
			}
			else if (core::stringw("dimension") == xmlConfig->getNodeName())
			{
				dim = dimension2d<s32>(xmlConfig->getAttributeValueAsInt(L"width"),xmlConfig->getAttributeValueAsInt(L"height"));
			}
			else if (core::stringw("local") == xmlConfig->getNodeName())
			{
				lang = xmlConfig->getAttributeValueAsInt(L"lang");
			}
			else if (core::stringw("main") == xmlConfig->getNodeName())
			{
				pathMain = xmlConfig->getAttributeValue(L"file");
			}
			else if (core::stringw("startmenu") == xmlConfig->getNodeName())
			{
				log(stringc("startmenu ") + xmlConfig->getAttributeValue(L"file"));
				pathStart = xmlConfig->getAttributeValue(L"file");
			}
		}
	}
	
	xmlConfig->drop();
	
	xmlConfig = device->getFileSystem()->createXMLReader(pathStart.c_str());
	
	if (xmlConfig)
		log(stringc("Finded startmenu main file ") + pathStart + " reading it...");
	else
	{
		log(stringc("Can't find startmenu main file ") + pathStart + " quitting...");
		return 2;
	}
	
	stringc pathLocal="";
	
	while(xmlConfig && xmlConfig->read())
	{
		if ( (xmlConfig->getNodeType()==EXN_ELEMENT) &&
		  (core::stringw("file") == xmlConfig->getNodeName()) &&
		  (stringc(xmlConfig->getAttributeValue(L"lang")) == langMenu) )
			pathLocal = xmlConfig->getAttributeValue(L"path");
	}
	
	xmlConfig->drop();
	
	xmlConfig = device->getFileSystem()->createXMLReader(pathLocal.c_str());
	
	if (xmlConfig)
		log(stringc("Finded startmenu local file ") + pathLocal + " reading it...");
	else
	{
		log(stringc("Can't find startmenu local file ") + pathLocal + " quitting...");
		return 2;
	}
	
	IGUIElement* element = 0;
	IGUIComboBox* combo = 0;
	stringc path = "./";
	position2d<int> actPos = position2d<int>(0,0);
	dimension2d<int> actDim = dimension2d<int>(0,0);
	
	while(xmlConfig && xmlConfig->read())
	{
		if (xmlConfig->getNodeType()==EXN_ELEMENT)
		{
			if (core::stringw("startmenu") == xmlConfig->getNodeName())
				device->setWindowCaption(xmlConfig->getAttributeValue(L"caption"));
			if (core::stringw("skin") == xmlConfig->getNodeName())
				env->getSkin()->setFont(env->getFont(stringc(xmlConfig->getAttributeValue(L"font")).c_str()));
			else if (core::stringw("main") == xmlConfig->getNodeName())
				element = env->addImage(driver->getTexture(stringc(xmlConfig->getAttributeValue(L"fond")).c_str()),
					position2d<int>(0,0),true,0,xmlConfig->getAttributeValueAsInt(L"id"));
			else if (core::stringw("color") == xmlConfig->getNodeName())
			{
				SColor col = SColor(xmlConfig->getAttributeValueAsInt(L"text"));
				col.setAlpha(255);
				env->getSkin()->setColor(EGDC_BUTTON_TEXT,col);
			}
			else if (core::stringw("general") == xmlConfig->getNodeName())
			{
				if (xmlConfig->getAttributeValue(L"path"))
					path = xmlConfig->getAttributeValue(L"path");
				if (xmlConfig->getAttributeValueAsInt(L"x"))
					actPos = position2d<int>(xmlConfig->getAttributeValueAsInt(L"x"),actPos.Y);
				if (xmlConfig->getAttributeValueAsInt(L"y"))
					actPos = position2d<int>(actPos.X,xmlConfig->getAttributeValueAsInt(L"y"));
				if (xmlConfig->getAttributeValueAsInt(L"w"))
					actDim = dimension2d<int>(xmlConfig->getAttributeValueAsInt(L"w"),actDim.Height);
				if (xmlConfig->getAttributeValueAsInt(L"h"))
					actDim = dimension2d<int>(actDim.Width,xmlConfig->getAttributeValueAsInt(L"h"));
			}
			else if (core::stringw("button") == xmlConfig->getNodeName())
			{
				menusOut->push_back(driver->getTexture((path + xmlConfig->getAttributeValue(L"out")).c_str()));
				menusIn->push_back(driver->getTexture((path + xmlConfig->getAttributeValue(L"in")).c_str()));
				IGUIButton *but = env->addButton(rect<s32>(actPos,actDim),element,xmlConfig->getAttributeValueAsInt(L"id"),L"");
				but->setImage(menusIn->back());
				but->setUseAlphaChannel (true);
				but->setDrawBorder (false);
				
				menus->push_back(but);
			}
			else if (core::stringw("combo") == xmlConfig->getNodeName())
			{
				env->addStaticText(xmlConfig->getAttributeValue(L"text"), rect<s32>(actPos,actDim),false,true,element,-1);
				combo = env->addComboBox(rect<s32>(actPos+position2d<int>(actDim.Width,0),actDim),
					element,xmlConfig->getAttributeValueAsInt(L"id"));
			}
			else if (core::stringw("item") == xmlConfig->getNodeName())
				combo->addItem(xmlConfig->getAttributeValue(L"txt"));
			else if (core::stringw("checkBox") == xmlConfig->getNodeName())
			{
				env->addStaticText(xmlConfig->getAttributeValue(L"text"), rect<s32>(actPos,actDim),false,true,element,-1);
				env->addCheckBox (false,rect<s32>(actPos+position2d<int>(actDim.Width,0),actDim),
					element, xmlConfig->getAttributeValueAsInt(L"id"));
			}
			else if (core::stringw("edit") == xmlConfig->getNodeName())
				env->addEditBox(xmlConfig->getAttributeValue(L"text"),rect<s32>(actPos,actDim),true,
					element,xmlConfig->getAttributeValueAsInt(L"id"));
			else if (core::stringw("static") == xmlConfig->getNodeName())
				env->addStaticText(xmlConfig->getAttributeValue(L"text"), rect<s32>(actPos,actDim),false,true,
					element,xmlConfig->getAttributeValueAsInt(L"id"));
			else if (core::stringw("image") == xmlConfig->getNodeName())
			{
				IGUIImage *image = env->addImage(rect<s32>(actPos,actDim),
					element,xmlConfig->getAttributeValueAsInt(L"id"));
				std::cout << actPos.X << " " << actPos.Y << " " << "\n";
				if (xmlConfig->getAttributeValue(L"path"))
					image->setImage(driver->getTexture(stringc(path + xmlConfig->getAttributeValue(L"path")).c_str()));
			}
			else if (core::stringw("launch") == xmlConfig->getNodeName())
				starting_txt->push_back(stringw(xmlConfig->getAttributeValue(L"text")));
		}
		else if (xmlConfig->getNodeType()==EXN_ELEMENT_END)
		{
			combo=0;
			if (core::stringw("combo") == xmlConfig->getNodeName())
				continue;
			actPos = position2d<int>(0,0);
			actDim = dimension2d<int>(0,0);
			path = "./";
			element=0;
		}
	}
	
	xmlConfig->drop();
	
	start=false;
	
	welcome = (IGUIImage*) env->getRootGUIElement()->getElementFromId(100);
	if (!welcome)
		;
	
	game = (IGUIImage*) env->getRootGUIElement()->getElementFromId(200);
	if (!game)
		;
	
	options = (IGUIImage*) env->getRootGUIElement()->getElementFromId(300);
	if (!options)
		;
	
	starting = (IGUIImage*) env->getRootGUIElement()->getElementFromId(400);
	if (!starting)
		;
	
	game_path = (IGUIEditBox*) game->getElementFromId(201);
	if (game_path)
		game_path->setText(stringw(pathMain).c_str());
	else
		;
	
	game_img = (IGUIImage*) game->getElementFromId(203);
	if (!game_img)
		;
	
	game_name = (IGUIStaticText*) game->getElementFromId(204);
	if (!game_name)
		;
	
	game_text = (IGUIStaticText*) game->getElementFromId(205);
	if (!game_text)
		;
	
	options_dv = (IGUIComboBox*) options->getElementFromId(301);
	if (options_dv)
		options_dv->setSelected(dr);
	else
		;
	
	options_res = (IGUIComboBox*) options->getElementFromId(302);
	if (options_res)
		for (unsigned int i=0;i<options_res->getItemCount();i++)
		{
			if ( ( stringw( options_res->getItem(i) ).find( stringw(dim.Height).c_str() )!=-1)
					&& ( stringw( options_res->getItem(i) ).find( stringw(dim.Width).c_str() ) !=-1))
				options_res->setSelected(i);
		}
	else
		;
	
	options_fs = (IGUICheckBox*) options->getElementFromId(303);
	if (options_fs)
		options_fs->setChecked(fullscreen);
	else
		;
	
	options_lang = (IGUIComboBox*) options->getElementFromId(304);
	if (options_lang)
		options_lang->setSelected(lang);
	else
		;
	
	starting_bar = (IGUIImage*) starting->getElementFromId(401);
	if (! starting_bar)
		;
	
	starting_text = (IGUIStaticText*) starting->getElementFromId(402);
	if (! starting_text)
		;
	
	welcome->setVisible(true);
	game->setVisible(false);
	options->setVisible(false);
	starting->setVisible(false);
	
	device->setEventReceiver(this);
	
	return 0;
}

int startmenu::update()
{
	int r = device->run();
	if (r && device->isWindowActive())
	{
		curPos=device->getCursorControl()->getPosition();
		
		for (unsigned int i=0;i<menus->size();i++)
		{
			if (menus->at(i)->isPointInside (curPos))
				menus->at(i)->setImage(menusIn->at(i));
			else
				menus->at(i)->setImage(menusOut->at(i));
		}
		
		driver->beginScene(true, true, SColor(0,0,0,0));
		
		env->drawAll();
		
		driver->endScene();
		if (q)
		{
			log("Quitting");
			close();
			return 0;
		}
		
		if (start)
		{
			start = false;
			startCoeur();
			return 0;
		}
	}
	return r;
}

int startmenu::close()
{
	device->drop();
	log("Irrlicht device drop");
	#ifdef AUDIO
	engine->drop();
	log("Irrklang engine drop");
	#endif
	log("startmenu is closed");
	return 1;
}

position2d<s32> startmenu::getCurPos()
{
	return curPos;
}

u32 startmenu::getTime()
{
	return device->getTimer()->getRealTime();
}

bool startmenu::OnEvent(const SEvent& event)
{
	if (event.EventType==EET_KEY_INPUT_EVENT)
	{
		if (event.KeyInput.PressedDown)
		{
			switch(event.KeyInput.Key)
			{
			case KEY_KEY_Q:
				q = true;
				return true;
			default:
				break;
			}
		}
	}else if(event.EventType==EET_GUI_EVENT)
	{
		int id = event.GUIEvent.Caller->getID();
		switch (event.GUIEvent.EventType)
		{
		case EGET_BUTTON_CLICKED:
			switch (id)
			{
			case 101:
				start=true;
				return true;
			case 102:
				return true;
			case 103:
				welcome->setVisible(false);
				game->setVisible(true);
				loadDesc();
				return true;
			case 104:
				welcome->setVisible(false);
				options->setVisible(true);
				return true;
			case 105:
				q = true;
			break;
			case 299:
				game->setVisible(false);
				welcome->setVisible(true);
				saveConfig();
			break;
			case 202:
				env->addFileOpenDialog (L"", true, 0, 221);
			break;
			case 399:
				options->setVisible(false);
				welcome->setVisible(true);
				saveConfig();
			break;
			default:
				
			break;
			}
		break;
		case EGET_FILE_SELECTED:
			if (!id==221)
				break;
			game_path->setText( ((IGUIFileOpenDialog*) event.GUIEvent.Caller)->getFileName() );
			device->getFileSystem()->changeWorkingDirectoryTo(path.c_str());
			loadDesc();
		break;
		case EGET_EDITBOX_ENTER:
			if (!id==201)
				break;
			if (!device->getFileSystem()->existFile(game_path->getText()))
				break;
			loadDesc();
		break;
		case EGET_COMBO_BOX_CHANGED:
			if (id==301)
				dr = E_DRIVER_TYPE(options_dv->getSelected());
			else if (id==302)
			{
				stringc temp = options_res->getItem (options_res->getSelected());
				int t = temp.find(L"x");
				dim = dimension2d<int>(fast_atof(temp.subString(0,t).c_str()),fast_atof(temp.subString(t+1,temp.size()-t).c_str()));
			}
			else if (id==304)
				lang = options_lang->getSelected();
		break;
		case EGET_CHECKBOX_CHANGED:
			if (id==303)
				fullscreen = options_fs->isChecked();
		break;
		default:
			
		break;
		}
	}
	return false;
}

stringc startmenu::getVersion()
{
	return stringc(VERSION);
}

int startmenu::setCaption(stringw caption)
{
	device->setWindowCaption(caption.c_str());
	log(stringc("Change window caption to ") + caption.c_str());
	return 1;
}

int startmenu::startCoeur()
{
	welcome->setVisible(false);
	game->setVisible(false);
	options->setVisible(false);
	starting->setVisible(true);
	
	log("Starting coeur");
	c = new coeur;
	if (c->init(this))
	{
		log("error initialising core");
		goto end;
	}
	log("Closing startmenu...");
	close();
	log("Coeur started"); 
	while(c->update());
end:
	log("Coeur ended");
	c->close();
	log("Coeur closed");
	delete c;
	log("Coeur deleted");
	
	return 1;
}

int startmenu::log(stringc text)
{
	std::cout << text.c_str() << "\n";
	return 1;
}

int startmenu::loadDesc()
{
	pathMain = game_path->getText();
	IXMLReader* xmlMain = device->getFileSystem()->createXMLReader(pathMain.c_str());
	
	game_img->setImage(0);
	game_name->setText(L"");
	game_text->setText(L"");
	
	stringc actualLang="";
	
	if (!xmlMain)
		return 1;
	
	while(xmlMain && xmlMain->read())
	{
		if (xmlMain->getNodeType()==EXN_ELEMENT)
		{
			if (core::stringw("description") == xmlMain->getNodeName())
			{
				actualLang = xmlMain->getAttributeValue(L"lang");
				if (langMenu == actualLang)
				{
					game_img->setImage(driver->getTexture(xmlMain->getAttributeValue(L"image")));
					game_name->setText(xmlMain->getAttributeValue(L"name"));
				}
			}
		}else if ( (xmlMain->getNodeType()==EXN_TEXT) && (langMenu==actualLang))
		{
			game_text->setText(xmlMain->getNodeData());
		}else if (xmlMain->getNodeType()==EXN_ELEMENT_END)
		{
			actualLang = "";
		}
	}

	xmlMain->drop();
	return 0;
}

int startmenu::saveConfig()
{
	IXMLWriter* xmlConfig = device->getFileSystem()->createXMLWriter(pathConfig.c_str());
	
	if (!xmlConfig)
		return 1;
	
	xmlConfig->writeXMLHeader();
	
	xmlConfig->writeElement(L"config");
	xmlConfig->writeLineBreak();
	xmlConfig->writeElement (L"device", true, L"driver", stringw(dr).c_str(),
		L"bits", stringw(bits).c_str(),
		L"fs", stringw(fullscreen).c_str(),
		L"sb", stringw(stencilbuffer).c_str(),
		L"vs", stringw(vsync).c_str()
		);
	
	xmlConfig->writeLineBreak();
	xmlConfig->writeElement (L"dimension", true, L"width", stringw(dim.Width).c_str(), L"height", stringw(dim.Height).c_str());
	xmlConfig->writeLineBreak();
	xmlConfig->writeLineBreak();
	
	xmlConfig->writeElement (L"main", true, L"file", stringw(pathMain).c_str());
	xmlConfig->writeLineBreak();
	
	xmlConfig->writeElement (L"local", true, L"lang", stringw(lang).c_str());
	xmlConfig->writeLineBreak();
	xmlConfig->writeLineBreak();
	
	xmlConfig->writeElement (L"startmenu", true, L"file", stringw(pathStart).c_str());
	xmlConfig->writeLineBreak();
	
	xmlConfig->writeClosingTag(L"config");
	xmlConfig->writeLineBreak();
	xmlConfig->writeLineBreak();

	xmlConfig->drop();
	
	return 1;
}

int startmenu::progress()
{
	log("progress");
	if (progressing>=starting_txt->size())
		return -1;
	starting_bar->setRelativePosition(
		rect<s32>(
			starting_bar->getRelativePosition().UpperLeftCorner,
			dimension2d<s32>( progressing*(560/starting_txt->size()) , 40 )
		)
	);
	starting_text->setText( ( stringw(int(100*progressing/starting_txt->size())) + stringw("% - ") + starting_txt->at(progressing)).c_str());
	progressing++;
	update();
	return 1;
}

IFileSystem* startmenu::getFileSystem()
{
	return device->getFileSystem();
}

